
/*************************************************
****                   VEGA                   ****
****     Color managment for OpenGL V1.0      ****
**** Copyright 1996-2001, Alessandro Pedretti ****
*************************************************/

#ifndef  __GL_COLORS_H
#  define  __GL_COLORS_H

/**** Color definitions ****/

#define  VGCOL_NONE             0
#define  VGCOL_BLACK            1
#define  VGCOL_WHITE            2
#define  VGCOL_RED              3
#define  VGCOL_GREEN            4
#define  VGCOL_BLUE             5
#define  VGCOL_CYAN             6
#define  VGCOL_YELLOW           7
#define  VGCOL_MAGENTA          8
#define  VGCOL_BROWN            9
#define  VGCOL_PINK            10
#define  VGCOL_VIOLET          11
#define  VGCOL_ORANGE          12

#define  VGCOL_NUM             12

/**** Macros ****/

#define GL_SetColor(ID) glColor3ub(ColorTable[(ID)].R, ColorTable[(ID)].G, ColorTable[(ID)].B)

/**** Structures ****/

typedef struct {
  char          *Name;          /* Pointer of color name */
  VG_UBYTE      R, G, B;        /* RGB values            */
  VG_UBYTE      ID;             /* Color ID              */
} VG_COLOR;

typedef struct {
  VG_DCHAR      Elem;           /* Element name          */
  VG_UBYTE      ColorID;        /* Color ID              */
} VG_ATMCOL;



#ifdef __COLORTABLE
VG_COLOR ColorTable[] = { {"NONE"   ,   0,   0,   0, VGCOL_NONE   },
                          {"BLACK"  ,   0,   0,   0, VGCOL_BLACK  },
                          {"WHITE"  , 255, 255, 255, VGCOL_WHITE  },
                          {"RED"    , 255,   0,   0, VGCOL_RED    },
                          {"GREEN"  ,   0, 255,   0, VGCOL_GREEN  },
                          {"BLUE"   ,   0,   0, 255, VGCOL_BLUE   },
                          {"CYAN"   ,   0, 255, 255, VGCOL_CYAN   },
                          {"YELLOW" , 255, 255,   0, VGCOL_YELLOW },
                          {"MAGENTA", 255,   0, 255, VGCOL_MAGENTA},
                          {"BROWN"  , 102,  51,  51, VGCOL_BROWN  },
                          {"PINK"   , 255, 153, 204, VGCOL_PINK   },
                          {"VIOLET" , 153,   0, 153, VGCOL_VIOLET },
                          {"ORANGE" , 255, 102,   0, VGCOL_ORANGE },
                          {NULL     ,   0,    0,  0, 255}
                        };

VG_ATMCOL AtmColTbl[] = { {{'C',  0 }, VGCOL_GREEN   },
                          {{'H',  0 }, VGCOL_WHITE   },
                          {{'N',  0 }, VGCOL_BLUE    },
                          {{'O',  0 }, VGCOL_RED     },
                          {{'S',  0 }, VGCOL_YELLOW  },
                          {{'F',  0 }, VGCOL_CYAN    },
                          {{'C', 'l'}, VGCOL_MAGENTA },
                          {{'B', 'r'}, VGCOL_ORANGE  },
                          {{'I',  0 }, VGCOL_VIOLET  },
                          {{ 0 ,  0 }, VGCOL_MAGENTA }
                        };
#else
extern VG_COLOR   ColorTable[];
extern VG_ATMCOL  AtmColTbl[];
#endif
#endif
