
/*************************************************
****                   VEGA                   ****
****           OpenGL Surfaces V1.0           ****
**** Copyright 1996-2000, Alessandro Pedretti ****
*************************************************/


#ifdef __WIN32__
#  include <windows.h>
#endif

#include <GL\gl.h>
#include <GL\glu.h>
#include <GL\glaux.h>
#include <stdio.h>

#include "globdef.h"
#include "globvar.h"
#include "formats.h"
#include "gl_global.h"
#include "gl_colors.h"


/**** Show the surface in OpenGL window ****/

void GL_ShowSrf(register VG_SURFACE *Dot)
{
  glPushMatrix();
    glBegin(GL_POINTS);
      while(Dot) {
        glColor3ubv(Dot -> Color);
        glVertex3f(Dot -> x, Dot -> y, Dot -> z);
        Dot = Dot -> Ptr;
      }
    glEnd();
  glPopMatrix();
}


/**** Save the surface in specified format ****/

VG_BOOL GL_SrfSave(char *File, VG_SURFACE *InizSrf, ATOMO *InizAtm,
                VG_UWORD Form, VG_UWORD PackMode)
{
  char          *Ext, *OpenWrtOpt;
  FILE          *FH;

  VG_BOOL       Ret = TRUE;

  Form &= 0x00ff;
  if (Form == SRF_QUANTA) OpenWrtOpt = "wb+";
  else OpenWrtOpt = "w";

  /**** Set the file extension (if needed) ****/

  if (!strchr(File, '.')) {
    if ((Form == SRF_VRML_POINTS) || (Form == SRF_VRML_POINTS))
      Ext = ".wrl";
    else Ext = ".srf";
    strcat(File, Ext);
  }
  AddPackExt(File, PackMode);

  if (FH = PkOpen(File, OpenWrtOpt, PackMode, TRUE)) {
    Ret = SrfSave(FH, File, InizSrf, InizAtm, Form);
    if (!PkClose(FH)) Ret = FALSE;
  } else Ret = FALSE;

  return Ret;
}




